%% Init
clear all 
close all
clc
% Target vector to recover
x = [1; .1; 1;1 ;10];
% Number of variables
n = length(x);
% Number of polynomials
N = 25;
% Max degree of the polynomials
degree = 4;
% Display setup
disp(['Seeking the solution to a polynomial equation system of degree ' ])
disp([num2str(degree) ' in ' num2str(n) ' dimensions and consisting of ' num2str(N) ' equations.' ])
disp(['The true x to be recovered is: '])
x

%% Generate data
% Compute the monomials
alpha = multiindex(n, degree);
M = size(alpha,1) - 1; % dimension of phi + 1
phi_x = zeros(M,1);
for k=1:M
    phi_x(k) = prod(x.^(alpha(k+1,:)'));  % k+1 because alpha(1,:) = 0 => constant b
end
% Draw random polynomial coefficients
Q = randn(N,M+1);
% Normalize columns (polybp functions do use precompensating weights yet)
normQ = sqrt(sum(Q.^2));
Q = Q./(ones(N,1) * normQ );
% Compute measurements
y = Q * [1;phi_x];

%% NLBP
% Generate Qs
[Qbar ybar] = transformQ(Q,n,degree,alpha,y);
% Set parameters
eps=1e-10;lambda=0;
% Compute estimate
xhatNLBP = NLBP_CVX(ybar,Qbar,eps,lambda,n);
disp('The x recovered by NLBP is: ')
xhatNLBP

