function [ Qbar y] = transformQ(Q,n,degree,alpha,y)
% [ Qbar y] = transformQ(Q,n,degree,alpha,y)
%
% Transform Q and y used in y = Q phi_x to
% Qbar(:,:,t) and ybar used in ybar(t) =
% phi2_x' Qbar(:,:,t) phi2_x and NLBP.
% Written by Henrik Ohlsson, ohlsson@isy.liu.se


%% Transform Q to Qbar
if mod(degree,2) ~= 0
    degree=degree+1;
end
T=size(Q,1);
m=1;
for i=1:degree/2
    m=m+nchoosek(n+i-1,i);
end
Qbar=zeros(m,m,T);
beta = multiindex(n,degree/2);
for ix=1:m
    for iy=1:m
        W(ix,iy,1:n) = beta(ix,:)+beta(iy,:);
    end
end
for i=1:size(alpha,1)
    for ix=1:m
        for iy=1:m
            if all(alpha(i,:)==squeeze(W(ix,iy,1:n))')
                ind(i,1:2) = [ix iy]';
            end
        end
    end
end


for t=1:T
    for i=1:size(alpha,1)
        Qbar(ind(i,1),ind(i,2),t)=Q(t,i);
    end
end

tic; % start counting time from here only...

if degree > 2
	%% Add constraints
	for ix=1:m
		for iy=1:m
		    for ix2=1:m
		        for iy2=1:m
		            if all(W(ix,iy,1:n)== W(ix2,iy2,1:n)) & (ix~=ix2 | iy~=iy2)
		                t=t+1;
		                Qbar(ix,iy,t) =1;
		                Qbar(ix2,iy2,t) =-1;
		                y(t)=0;
		            end
		        end
		        
		    end
		end
	end
end

t=t+1;
Qbar(1,1,t) =1;
y(t)=1;
